=pod

=encoding utf-8

=head1 PURPOSE

Print version numbers, etc.

=head1 AUTHOR

Toby Inkster E<lt>tobyink@cpan.orgE<gt>.

=head1 COPYRIGHT AND LICENCE

This software is copyright (c) 2022 by Toby Inkster.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

=cut

use 5.014;
use Test2::V0;

my @modules = qw(
	Carp
	Exporter::Shiny
	Lexical::Sub
	Role::Tiny
	Scalar::Util
	Syntax::Keyword::Try
);

diag "\n####";
for my $mod ( sort @modules ) {
	eval( "require $mod; 1" )
		? diag( sprintf( '%-20s %s', $mod, $mod->VERSION ) )
		: diag( sprintf( '%-20s x', $mod ) );
}
diag "####";

pass;

done_testing;

